/* This is the main-file for the AVR-SoC by Mario Mauerer
Jan 2010

It lets the upper 4 LEDs on the Xilinx-Spartan-3e starter kit blink.
The lower 4 LEDs can be controlled with the 4 sliding switches on the board. 
The uart is used to print "Hello World" continuously.
*/

#include <avr/io.h>
#include <util/delay.h>

#include "AVR_Softcore_main.h"
#include "uart.h"
#include "lcd.h"


int main(void)
{

	uart_init(); //get the UART running

	LEDS = 0x00; //initialize the LEDs

	lcd_init(); //initialize the LCD of the stater-kit board and display something.

	uint16_t counter1 = 0; //used as a timer (for the blinking)

	while(1)
	{
		
		LEDS = (LEDS | 0b00001111)&(0b11110000 | SliSwi) ; //only alter the lower 4 LEDs with the sliding switches.

		counter1++;
		if(counter1 == 65534) 
		{
			counter1 = 0;
			uart_printstring("Hello World"); //print something to the wide world
			LEDS ^= 0b11110000; //invert the upper 4 LEDs ==> blinking.
		}
	

	}

}





