#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"
#include "AVR_Softcore_main.h"


void lcd_init(void) //initializes the LCD 
{
	LCD = 0x00; //Initialize FPGA-Register
	LCD |= (1<<7); //Disable the Strata-Flash
	
	LCD = (LCD & 0xF0) | 0x03; //set up 4-bit transfer (see datasheet of the LCD controller)
	LCD |= (1<<LCD_E);
	_delay_us(1);
	LCD &= ~(1<<LCD_E);
	_delay_us(40);


	lcd_datasend(0x28); //Function Set
	lcd_datasend(0x28); //Function Set
	lcd_datasend(0x0F); //On/Off Control
	lcd_datasend(0x01); //Display Clear
	lcd_datasend(0x06); //Entry mode set

	//Display "MARIO" on the Screen:
_delay_ms(10);
	lcd_datasend(0x80); //set Adress to 0x00
	LCD |= (1<<LCD_RS);
	lcd_datasend(0x4D);//Write MARIO
	lcd_datasend(0x41);
	lcd_datasend(0x52);
	lcd_datasend(0x49);
	lcd_datasend(0x4F);
	LCD &= ~(1<<LCD_RS);

	
}

void lcd_datasend(uint8_t input) //this writes an entire bytes to the LCD. ==> Two transfers! (4-bit access to LCD!)
{
	uint8_t uppernibble = 0x00;
	uint8_t lowernibble = 0x00;

	lowernibble = input & 0x0F;
	uppernibble = input & 0xF0;
	uppernibble = uppernibble >> 4;

	LCD = (LCD & 0xF0) | uppernibble;
	LCD |= (1<<LCD_E);
	_delay_us(1);
	LCD &= ~(1<<LCD_E);
	_delay_us(2);

	LCD = (LCD & 0xF0) | lowernibble;
	LCD |= (1<<LCD_E);
	_delay_us(1);
	LCD &= ~(1<<LCD_E);
	_delay_us(40);

}

